import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class tinyScramble extends Applet
    implements Runnable {		// Threaded application
 
    int delay=10, 			// delay, controls scroll speed
      length,                           // Length of input string
      numHits=0,			// Number of correct hits
      xpos=0,                           // X position
      ypos=0;                           // Y position

    Image offImage, bg;                 // Double buffering to eliminate
    Graphics offGrfx;                   // frame flicker

    Color background, fontColor;

    Thread runner;

    String outString = new String("");
    String Message = new String("");

    Font outFont;

    public void init() {
        int size;

        /****  Get attributes, if available  ****/
        String bgRed$      = getParameter("BGRED");
        String bgGreen$    = getParameter("BGGREEN");
        String bgBlue$     = getParameter("BGBLUE");
        String fgRed$      = getParameter("FGRED");
        String fgGreen$    = getParameter("FGGREEN");
        String fgBlue$     = getParameter("FGBLUE");
        String background$ = getParameter("BACKGROUND");
        String delay$      = getParameter("DELAY");
        String fontName$   = getParameter("FONTNAME");
        String fontSize$   = getParameter("FONTSIZE");
        String xpos$       = getParameter("XPOS");
        String ypos$       = getParameter("YPOS");
               Message     = getParameter("MESSAGE");

        /****    Prep execute attributes    ****/
        if (xpos$ != null) 
	  xpos = Integer.parseInt(xpos$);

        if (ypos$ != null) 
	  ypos = Integer.parseInt(ypos$);

        if (delay$ != null) 
	  delay = Integer.parseInt(delay$);

        if ((fontSize$ != null) && (fontName$ != null)) {
            size = Integer.parseInt(fontSize$);
            outFont = new Font(fontName$, Font.PLAIN, size);
        }

        /****    Prep string information    ****/
        length = Message.length();

        /****      Convert color values     ****/
        int Red=255;
        if (bgRed$ != null)
	  Red = Integer.parseInt(bgRed$);

        int Green=255; 
        if (bgGreen$ != null)
	  Green = Integer.parseInt(bgGreen$);

        int Blue=255;
        if (bgBlue$ != null)
	  Blue = Integer.parseInt(bgBlue$);

        int fRed=0;
        if (fgRed$ != null)
          fRed = Integer.parseInt(fgRed$);

        int fGreen=0; 
        if (fgGreen$ != null)
          fGreen = Integer.parseInt(fgGreen$);

        int fBlue=0;
        if (fgBlue$ != null)
          fBlue = Integer.parseInt(fgBlue$);

        if (background$ !=null)
          bg = getImage(getDocumentBase(), background$);

        /****     Set background color    ****/
        fontColor = new Color(fRed, fGreen, fBlue);

        /****     Set background color    ****/
        background = new Color(Red, Green, Blue);
        setBackground(background);

        offImage = createImage(size().width, size().height);
        offGrfx = offImage.getGraphics();
    }

    public void paint(Graphics screen) {
          offGrfx.setColor(background);
          offGrfx.fillRect(0,0,size().width, size().height);
          if (bg != null)
            offGrfx.drawImage(bg, 0, 0, null);
          offGrfx.setColor(fontColor);
          if (outFont != null) offGrfx.setFont(outFont);
          offGrfx.drawString(outString, xpos, ypos);
          screen.drawImage(offImage, 0, 0, this);
    }

    public void update(Graphics screen) {
          paint(screen); 
    }

    public void start() {
        if (runner == null) {
            runner = new Thread(this);
            runner.start();
        }
    }

    public char genRandomChar() {
        double tmpDbl = Math.random()*90;
        return (char)(Math.floor(tmpDbl)+32);
    }

    public void run() {
        int[] hits = new int[length];
        char[] output = new char[length];
        char[] input = new char[length];
 
        for(int x=0;x<length;x++) hits[x]=0; 
        input = Message.toCharArray();

        FontMetrics fm = getFontMetrics(outFont);

        if (xpos==0) xpos = (int)(0.5 * (size().width - fm.stringWidth(Message)));
        if (ypos==0) ypos = (int)(0.5 * (size().height - fm.getHeight()));

        while (numHits!=length) {
            for(int x=0;x<length;x++){
                if (hits[x]!=1) {
                    output[x] = genRandomChar();
                    if (output[x]==input[x]){
                       hits[x]=1;
                       numHits++;
                    }
                }
            }
            outString = new String(output);
            repaint();
            try { Thread.sleep(delay); }
            catch (InterruptedException e) { }
        }
    }

    public void stop() {
        if (runner != null) {
            runner.stop();
            runner = null;
        }
    }
}
